<?php
namespace nur\sery\file\csv;

use nur\sery\file\FileReader;

class CsvReader extends AbstractReader {
  use TAbstractReader;

  function __construct($input, ?array $params=null) {
    parent::__construct($input, $params);
    $this->csvFlavour = $params["csv_flavour"] ?? null;
  }

  protected ?string $csvFlavour;

  function getIterator() {
    $reader = new FileReader($this->input);
    $reader->setCsvFlavour($this->csvFlavour);
    while (($row = $reader->fgetcsv()) !== null) {
      foreach ($row as &$col) {
        $this->verifixCol($col);
      }; unset($col);
      if ($this->cook($row)) {
        yield $row;
        $this->idest++;
      }
      $this->isrc++;
    }
    $reader->close();
  }
}
